(* ------------------------------------------------------ *)
(*                    MEMSHOW.PAS                         *)
(*          (c) 1990 Ulf Kepper & TOOLBOX                 *)
(* ------------------------------------------------------ *)
PROGRAM MemShow;

USES Dos, Crt;

TYPE
  Buffer = ARRAY [0..1234] OF BYTE;

VAR
  p        : ^Buffer;
  OldTimer : POINTER;
  j        : INTEGER;

  PROCEDURE Show(Flags, CS, IP, AX, BX, CX, DX,
                            SI, DI, DS, ES, BP: WORD);
  INTERRUPT;
  VAR
    M  : LONGINT;
    St : STRING;
    i  : INTEGER;
  BEGIN
    M := MemAvail;
    Str(M, St);
    FOR i := 1 TO 8 DO
      Mem[$b800:100+2*i] := Ord(St[i]);    { Fr HGC $b000 }
  END;

BEGIN
  ClrScr;
                { diese beiden Interrupt-Befehle am Anfang }
                { des Programmlaufs einfgen               }

  GetIntVec(28, OldTimer);
  SetIntVec(28, @Show);

  FOR j := 1 TO 5 DO BEGIN
    New(p);
    Delay(500);
    Dispose(P);
    Delay(500);
  END;
                 { Diesen Interrupt-Befehl ans Ende des    }
                 { Programmlaufs stellen.                  }
                 { Sollte das Programm schon vorher abge-  }
                 { brochen werden, wird der alte           }
                 { Timer-Vektor nicht mehr restauriert und }
                 { der Zeiger 'hngt in der Luft'.         }

  SetIntVec(28, OldTimer);
END.
(* ------------------------------------------------------ *)
(*                 Ende von MEMSHOW.PAS                   *)
